# HG changeset patch
# User Markus Mützel <markus.muetzel@gmx.de>
# Date 1638189809 -3600
#      Mon Nov 29 13:43:29 2021 +0100
# Node ID e40a599d68cf3061d04a9dac30e36751ed20acb2
# Parent  71f2c8fde0c59f4942dd22da89bba162e8ae6c97
Remove usage of `error_state` (bug #).

* src/pcregexp.cc (many files): Remove usage of `error_state`. It was
unconditionally set to 0 since about 6 years ago and will finally be removed in
Octave 8.

diff -r 71f2c8fde0c5 -r e40a599d68cf src/__boxcount__.cc
--- a/src/__boxcount__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__boxcount__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -194,89 +194,85 @@
 
       octave_idx_type length=LENGTH-(maxembed-1)*DELAY;
 
-      if ( ! error_state)
+      // Calculate output
+      double heps              = EPSMAX*EPSFAKTOR;
+      octave_idx_type epsi_old = 0;
+      for (octave_idx_type k=0;k<EPSCOUNT;k++)
         {
-          // Calculate output
-          double heps              = EPSMAX*EPSFAKTOR;
-          octave_idx_type epsi_old = 0;
-          for (octave_idx_type k=0;k<EPSCOUNT;k++)
-            {
+
+          octave_idx_type epsi_test;
+          do {
+            heps /= EPSFAKTOR;
+            epsi_test=(octave_idx_type)(1./heps);
+          } while (epsi_test <= epsi_old);
+
+          octave_idx_type epsi = epsi_test;
+          epsi_old             = epsi;
+          deps[k]              = heps;
+
+          std::vector <double> histo (maxembed * dimension, 0.0);
+          start_box(series, which_dims, histo, maxembed, dimension, DELAY,
+                    length, epsi, Q);
 
-              octave_idx_type epsi_test;
-              do {
-                heps /= EPSFAKTOR;
-                epsi_test=(octave_idx_type)(1./heps);
-              } while (epsi_test <= epsi_old);
+          if (Q != 1.0)
+            for (std::vector<double>::iterator it = histo.begin ();
+                 it != histo.end (); it++)
+              *it = log(*it)/(1.0-Q);
+
+          histo_list.push_back (histo);
+        }
+
+      // Create and assign output
+      dim_vector dv (maxembed, dimension);
+      string_vector keys;
+      keys.append (std::string("dim"));
+      keys.append (std::string("entropy"));
+      octave_map output (dv, keys);
 
-              octave_idx_type epsi = epsi_test;
-              epsi_old             = epsi;
-              deps[k]              = heps;
+      for (octave_idx_type i=0;i<maxembed*dimension;i++)
+        {
+          octave_scalar_map tmp (keys);
+          // old fprintf(fHq,"#component = %d embedding = %d\n",
+          //             which_dims[i][0]+1, which_dims[i][1]+1);
+
+          tmp.setfield ("dim", which_dims[i][1]+1);
+
+          // Create entropy output 
+          Matrix entropy_out (EPSCOUNT, 3);
 
-              std::vector <double> histo (maxembed * dimension, 0.0);
-              start_box(series, which_dims, histo, maxembed, dimension, DELAY,
-                        length, epsi, Q);
-
-              if (Q != 1.0)
-                for (std::vector<double>::iterator it = histo.begin ();
-                     it != histo.end (); it++)
-                  *it = log(*it)/(1.0-Q);
-
-              histo_list.push_back (histo);
+          std::list<std::vector<double>>::const_iterator it_hist;
+          it_hist = histo_list.cbegin ();
+          for (octave_idx_type j=0;j<EPSCOUNT;j++)
+            {
+              if (i == 0)
+                {
+                  // old fprintf(fHq,"%e %e %e\n",deps[j]*maxinterval,
+                  //             histo_el->hist[i],histo_el->hist[i]);
+                  entropy_out(j,0) = deps[j]*maxinterval;
+                  entropy_out(j,1) = (*it_hist)[i];
+                  entropy_out(j,2) = (*it_hist)[i];
+                }
+              else
+                {
+                  // old fprintf(fHq,"%e %e %e\n",deps[j]*maxinterval,
+                  //             histo_el->hist[i],
+                  //             histo_el->hist[i]-histo_el->hist[i-1]);
+                  entropy_out(j,0) = deps[j]*maxinterval;
+                  entropy_out(j,1) = (*it_hist)[i];
+                  entropy_out(j,2) = (*it_hist)[i]
+                                     - (*it_hist)[i-1];
+                }
+              it_hist++;
             }
 
-          // Create and assign output
-          dim_vector dv (maxembed, dimension);
-          string_vector keys;
-          keys.append (std::string("dim"));
-          keys.append (std::string("entropy"));
-          octave_map output (dv, keys);
-
-          for (octave_idx_type i=0;i<maxembed*dimension;i++)
-            {
-              octave_scalar_map tmp (keys);
-              // old fprintf(fHq,"#component = %d embedding = %d\n",
-              //             which_dims[i][0]+1, which_dims[i][1]+1);
-
-              tmp.setfield ("dim", which_dims[i][1]+1);
-
-              // Create entropy output 
-              Matrix entropy_out (EPSCOUNT, 3);
+          tmp.setfield ("entropy",entropy_out);
 
-              std::list<std::vector<double>>::const_iterator it_hist;
-              it_hist = histo_list.cbegin ();
-              for (octave_idx_type j=0;j<EPSCOUNT;j++)
-                {
-                  if (i == 0)
-                    {
-                      // old fprintf(fHq,"%e %e %e\n",deps[j]*maxinterval,
-                      //             histo_el->hist[i],histo_el->hist[i]);
-                      entropy_out(j,0) = deps[j]*maxinterval;
-                      entropy_out(j,1) = (*it_hist)[i];
-                      entropy_out(j,2) = (*it_hist)[i];
-                    }
-                  else
-                    {
-                      // old fprintf(fHq,"%e %e %e\n",deps[j]*maxinterval,
-                      //             histo_el->hist[i],
-                      //             histo_el->hist[i]-histo_el->hist[i-1]);
-                      entropy_out(j,0) = deps[j]*maxinterval;
-                      entropy_out(j,1) = (*it_hist)[i];
-                      entropy_out(j,2) = (*it_hist)[i]
-                                         - (*it_hist)[i-1];
-                    }
-                  it_hist++;
-                }
+          output.assign (idx_vector(which_dims[i][1]),
+                         idx_vector(which_dims[i][0]),
+                         tmp);
+        }
 
-              tmp.setfield ("entropy",entropy_out);
-
-              output.assign (idx_vector(which_dims[i][1]),
-                             idx_vector(which_dims[i][0]),
-                             tmp);
-            }
-
-
-          retval(0) = output;
-        }
+      retval(0) = output;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__c1__.cc
--- a/src/__c1__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__c1__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -85,65 +85,61 @@
       F77_INT iverb          = TO_F77_INT (verbose);
 
 
-      if (! error_state)
-        {
-
-          F77_INT lines_read   = TO_F77_INT (input.rows ()); //nmax in d1()
-          F77_INT columns_read = TO_F77_INT (input.columns ());
+      F77_INT lines_read   = TO_F77_INT (input.rows ()); //nmax in d1()
+      F77_INT columns_read = TO_F77_INT (input.columns ());
 
 
-          dim_vector dv (maxdim - mindim + 1, 1);
-          string_vector keys;
-          keys.append (std::string("dim"));
-          keys.append (std::string("c1"));
-          octave_map output (dv, keys);
+      dim_vector dv (maxdim - mindim + 1, 1);
+      string_vector keys;
+      keys.append (std::string("dim"));
+      keys.append (std::string("c1"));
+      octave_map output (dv, keys);
+
+      // Seed the rand() function for d1()
+      F77_XFCN (rand, RAND, (sqrt(seed)));
 
-          // Seed the rand() function for d1()
-          F77_XFCN (rand, RAND, (sqrt(seed)));
+      for (F77_INT m = mindim; m <= maxdim; m++)
+        {
+          octave_scalar_map tmp (keys);
+          tmp.setfield ("dim", m);
 
-          for (F77_INT m = mindim; m <= maxdim; m++)
+          // Creat c1 output
+          Matrix c1_out ((octave_idx_type) ((0 - log (1./(lines_read 
+                                                     -(m-1) * delay)) +
+                                            (log (2.) /resolution)) 
+                                                 / (log (2.) /resolution))
+                         , 2);
+
+          double pr = 0.0;
+          octave_idx_type current_row = 0;
+          for (double pl = log (1./(lines_read - (m-1)*delay));
+               pl <= 0.0; pl += log (2.) / resolution)
             {
-              octave_scalar_map tmp (keys);
-              tmp.setfield ("dim", m);
+              double pln = pl;
+              double rln;
 
-              // Creat c1 output
-              Matrix c1_out ((octave_idx_type) ((0 - log (1./(lines_read 
-                                                         -(m-1) * delay)) +
-                                                (log (2.) /resolution)) 
-                                                     / (log (2.) /resolution))
-                             , 2);
+              F77_XFCN (d1, D1,
+                        (lines_read, columns_read, lines_read,
+                         input.fortran_vec (), delay, m, cmin,
+                         pr, pln, rln, tmin, kmax, iverb));
 
-              double pr = 0.0;
-              octave_idx_type current_row = 0;
-              for (double pl = log (1./(lines_read - (m-1)*delay));
-                   pl <= 0.0; pl += log (2.) / resolution)
+              if (pln != pr)
                 {
-                  double pln = pl;
-                  double rln;
-
-                  F77_XFCN (d1, D1,
-                            (lines_read, columns_read, lines_read,
-                             input.fortran_vec (), delay, m, cmin,
-                             pr, pln, rln, tmin, kmax, iverb));
+                  pr = pln;
+                  c1_out(current_row,0) = exp (rln);
+                  c1_out(current_row,1) = exp (pln);
+                  current_row += 1;
+                }
 
-                  if (pln != pr)
-                    {
-                      pr = pln;
-                      c1_out(current_row,0) = exp (rln);
-                      c1_out(current_row,1) = exp (pln);
-                      current_row += 1;
-                    }
+            }
+          // Resize output
+          c1_out.resize (current_row, 2);
+          tmp.setfield ("c1", c1_out);
 
-                }
-              // Resize output
-              c1_out.resize (current_row, 2);
-              tmp.setfield ("c1", c1_out);
+          output.assign (idx_vector(m-mindim), tmp);
+        }
 
-              output.assign (idx_vector(m-mindim), tmp);
-            }
-
-          retval(0) = output;
-        }
+      retval(0) = output;
     }
   return retval;
 }
diff -r 71f2c8fde0c5 -r e40a599d68cf src/__d2__.cc
--- a/src/__d2__.cc	Mon Aug 26 12:51:20 2019 -0400
+++ b/src/__d2__.cc	Mon Nov 29 13:43:29 2021 +0100
@@ -365,251 +365,247 @@
       time_t lasttime;
       time(&lasttime);
 
-      if (! error_state)
+      bool imin_too_large = false;
+      bool pause_calc     = false;
+      // Calculate the outputs
+      for (octave_idx_type n = 1 + counter; n < nmax && !imin_too_large
+                                            && !pause_calc; n++)
         {
-
-          bool imin_too_large = false;
-          bool pause_calc     = false;
-          // Calculate the outputs
-          for (octave_idx_type n = 1 + counter; n < nmax && !imin_too_large
-                                                && !pause_calc; n++)
+          counter           += 1;
+          bool smaller       = 0;
+          octave_idx_type sn = scr[n-1];
+          double epsinv      = 1.0 / EPSMAX;
+          octave_idx_type x,y;
+          if (DIM > 1)
             {
-              counter           += 1;
-              bool smaller       = 0;
-              octave_idx_type sn = scr[n-1];
-              double epsinv      = 1.0 / EPSMAX;
-              octave_idx_type x,y;
-              if (DIM > 1)
-                {
-                  x=(octave_idx_type)(series[0][sn]*epsinv)&(NMAX-1);
-                  y=(octave_idx_type)(series[1][sn]*epsinv)&(NMAX-1);
-                }
-              else
-                {
-                  x=(octave_idx_type)(series[0][sn]*epsinv)&(NMAX-1);
-                  y=(octave_idx_type)(series[0][sn+DELAY]*epsinv)&(NMAX-1);
-                }
-              list[sn]=box[x][y];
-              box[x][y]=sn;
-              listc1[sn]=boxc1[x];
-              boxc1[x]=sn;
+              x=(octave_idx_type)(series[0][sn]*epsinv)&(NMAX-1);
+              y=(octave_idx_type)(series[1][sn]*epsinv)&(NMAX-1);
+            }
+          else
+            {
+              x=(octave_idx_type)(series[0][sn]*epsinv)&(NMAX-1);
+              y=(octave_idx_type)(series[0][sn+DELAY]*epsinv)&(NMAX-1);
+            }
+          list[sn]=box[x][y];
+          box[x][y]=sn;
+          listc1[sn]=boxc1[x];
+          boxc1[x]=sn;
 
-              octave_idx_type i=imin;
-              while (found[maxembed][i] >= MAXFOUND)
-                {
-                  smaller=1;
-                  if (++i > (HOWOFTEN-1))
-                    break;
-                }
-              if (smaller)
-                {
-                  imin=i;
-                  if (imin <= (HOWOFTEN-1))
-                    {
-                      EPSMAX        = epsm[imin];
-                      double epsinv = 1.0/EPSMAX;
-                      for (octave_idx_type i1=0;i1<NMAX;i1++)
-                        {
-                          boxc1[i1]= -1;
-                          for (octave_idx_type j1=0;j1<NMAX;j1++)
-                            box[i1][j1]= -1;
-                        }
-                      for (octave_idx_type i1=0;i1<n;i1++)
-                        {
-                          sn=scr[i1];
-                          octave_idx_type x,y;
-                          if (DIM > 1)
-                            {
-                              x=(octave_idx_type)(series[0][sn]*epsinv)
-                                &(NMAX-1);
-                              y=(octave_idx_type)(series[1][sn]*epsinv)
-                                &(NMAX-1);
-                            }
-                          else
-                            {
-                              x=(octave_idx_type)(series[0][sn]*epsinv)
-                                &(NMAX-1);
-                              y=(octave_idx_type)(series[0][sn+DELAY]*epsinv)
-                                &(NMAX-1);
-                            }
-                          list[sn]=box[x][y];
-                          box[x][y]=sn;
-                          listc1[sn]=boxc1[x];
-                          boxc1[x]=sn;
-                        }
-                    }
-                }
-
+          octave_idx_type i=imin;
+          while (found[maxembed][i] >= MAXFOUND)
+            {
+              smaller=1;
+              if (++i > (HOWOFTEN-1))
+                break;
+            }
+          if (smaller)
+            {
+              imin=i;
               if (imin <= (HOWOFTEN-1))
                 {
-                  octave_idx_type lnorm=n;
-                  if (MINDIST > 0)
+                  EPSMAX        = epsm[imin];
+                  double epsinv = 1.0/EPSMAX;
+                  for (octave_idx_type i1=0;i1<NMAX;i1++)
                     {
-                      octave_idx_type sn=scr[n];
-                      octave_idx_type n1=(sn-MINDIST>=0)?sn-MINDIST:0;
-                      octave_idx_type n2=(sn+MINDIST<length-(EMBED-1)*DELAY)
-                                         ?sn+MINDIST:length-(EMBED-1)*DELAY-1;
-                      for (octave_idx_type i1=n1;i1<=n2;i1++)
-                        if ((oscr[i1] < n))
-                          lnorm--;
+                      boxc1[i1]= -1;
+                      for (octave_idx_type j1=0;j1<NMAX;j1++)
+                        box[i1][j1]= -1;
                     }
-
-                  if (EMBED*DIM > 1)
-                    make_c2_dim(series, found, list, box, DIM, imin, EPSMAX1,
-                                EPSMAX, EPSMIN, EMBED, DELAY, MINDIST,
-                                HOWOFTEN, scr[n]);
-                  make_c2_1(series, found, listc1, boxc1, imin, EPSMAX1,
-                            EPSMAX, EPSMIN, MINDIST, HOWOFTEN, scr[n]);
-                  for (octave_idx_type i=imin;i<HOWOFTEN;i++)
-                    norm[i] += (double)(lnorm);
-                }
-
-
-              // If any of the below occurs: pause or end.
-              if (((time(NULL)-lasttime) > WHEN) || (n == (nmax-1)) || 
-                  (imin > (HOWOFTEN-1)) || (counter % it_pause == 0))
-                {
-                  time(&lasttime);
-
-                  if (imin > (HOWOFTEN-1))
+                  for (octave_idx_type i1=0;i1<n;i1++)
                     {
-                      // old exit(0);
-                      imin_too_large = true;
+                      sn=scr[i1];
+                      octave_idx_type x,y;
+                      if (DIM > 1)
+                        {
+                          x=(octave_idx_type)(series[0][sn]*epsinv)
+                            &(NMAX-1);
+                          y=(octave_idx_type)(series[1][sn]*epsinv)
+                            &(NMAX-1);
+                        }
+                      else
+                        {
+                          x=(octave_idx_type)(series[0][sn]*epsinv)
+                            &(NMAX-1);
+                          y=(octave_idx_type)(series[0][sn+DELAY]*epsinv)
+                            &(NMAX-1);
+                        }
+                      list[sn]=box[x][y];
+                      box[x][y]=sn;
+                      listc1[sn]=boxc1[x];
+                      boxc1[x]=sn;
                     }
-                  pause_calc = true;
                 }
             }
 
-          // Create vars output
-          octave_scalar_map vars;
-
-
-          // Create vars output
-          // old fprintf(fstat,"Center points treated so far= %ld\n",n);
-          vars.setfield ("treated", counter);
-          // old fprintf(fstat,"Maximum epsilon in the moment= %e\n",
-          //             epsm[imin]);
-          vars.setfield ("eps", epsm[imin]);
-
-          if (counter < nmax - 1 && imin_too_large == false)
+          if (imin <= (HOWOFTEN-1))
             {
-              vars.setfield ("counter", counter);
-              vars.setfield ("found", found_matrix);
-              vars.setfield ("norm", norm_matrix);
-              vars.setfield ("boxc1", boxc1_matrix);
-              vars.setfield ("box", box_matrix);
-              vars.setfield ("list", list_matrix);
-              vars.setfield ("listc1", listc1_matrix);
-              vars.setfield ("imin", imin);
-              vars.setfield ("EPSMAX1",EPSMAX1);
-              vars.setfield ("EPSMAX", EPSMAX);
-              vars.setfield ("EPSMIN", EPSMIN);
-            }
-
-          // Create values output
-          dim_vector dv (DIM * EMBED, 1);
-          string_vector keys;
-          keys.append (std::string("dim"));
-          keys.append (std::string("c2"));
-          keys.append (std::string("d2"));
-          keys.append (std::string("h2"));
-          octave_map values (dv, keys);
-
-          for (octave_idx_type i=0;i<DIM*EMBED;i++)
-            {
-
-              octave_scalar_map tmp (keys);
-
-              // old fprintf(fout,"#dim= %ld\n",i+1);
-              tmp.setfield ("dim", i+1);
-
-              // Allocate d2 output
-              Matrix d2_out (HOWOFTEN - 1, 2);
-              octave_idx_type d2_row = 0;
-
-              // Allocate h2 output
-              Matrix h2_out (HOWOFTEN, 2);
-              octave_idx_type h2_row = 0;
-
-              // Allocate c2 output
-              Matrix c2_out (HOWOFTEN, 2);
-              octave_idx_type c2_row = 0;
-
-              double eps = EPSMAX1 * epsfactor;
-
-              for (octave_idx_type j=0;j<HOWOFTEN;j++)
+              octave_idx_type lnorm=n;
+              if (MINDIST > 0)
                 {
-                  eps /= epsfactor;
+                  octave_idx_type sn=scr[n];
+                  octave_idx_type n1=(sn-MINDIST>=0)?sn-MINDIST:0;
+                  octave_idx_type n2=(sn+MINDIST<length-(EMBED-1)*DELAY)
+                                     ?sn+MINDIST:length-(EMBED-1)*DELAY-1;
+                  for (octave_idx_type i1=n1;i1<=n2;i1++)
+                    if ((oscr[i1] < n))
+                      lnorm--;
+                }
 
-                  // Calculate d2 output
-                  if ((j > 0) && (found[i][j] > 0.0)
-                      && (found[i][j-1] > 0.0))
-                    {
-                      // old fprintf(fout,"%e %e\n",eps,
-                      //      log(found[i][j-1]/found[i][j]/norm[j-1]
-                      //          *norm[j])
-                      //      /log(epsfactor));
-                      d2_out(d2_row,0) = eps;
-                      d2_out(d2_row,1) = log(found[i][j-1]/found[i][j]
-                                             /norm[j-1]*norm[j])
-                                         /log(epsfactor);
-                      d2_row          += 1;
-                    }
-
-                  // Calculate h2 output
-                  if (i < 1)
-                    {
-                      if (found[0][j] > 0.0)
-                        {
-                          // old fprintf(fout,"%e %e\n",eps,
-                          //             -log(found[0][j]/norm[j]));
-                          h2_out(h2_row,0) = eps;
-                          h2_out(h2_row,1) = -log(found[0][j]/norm[j]);
-                          h2_row          += 1;
-                        }
-                    }
-                  else
-                    {
-                      if ((found[i-1][j] > 0.0) && (found[i][j] > 0.0))
-                        {
-                        // old fprintf(fout,"%e %e\n",eps,
-                        //             log(found[i-1][j]/found[i][j]));
-                          h2_out(h2_row,0) = eps;
-                          h2_out(h2_row,1) = log(found[i-1][j]
-                                                 /found[i][j]);
-                          h2_row          += 1;
-                        }
-                    }
-
-                  // Calculate c2 output
-                  if (norm[j] > 0.0)
-                    {
-                      // old fprintf(fout,"%e %e\n",eps,
-                      //             found[i][j]/norm[j]);
-                      c2_out(c2_row,0) = eps;
-                      c2_out(c2_row,1) = found[i][j]/norm[j];
-                      c2_row          += 1;
-                    }
-                }
-              // Prepare d2 output
-              d2_out.resize (d2_row, 2);
-              tmp.setfield ("d2", d2_out);
-              // Prepare h2 output
-              h2_out.resize (h2_row, 2);
-              tmp.setfield ("h2", h2_out);
-              // Prepare c2 output
-              c2_out.resize (c2_row, 2);
-              tmp.setfield ("c2", c2_out);
-
-              values.assign (idx_vector(i), tmp);
+              if (EMBED*DIM > 1)
+                make_c2_dim(series, found, list, box, DIM, imin, EPSMAX1,
+                            EPSMAX, EPSMIN, EMBED, DELAY, MINDIST,
+                            HOWOFTEN, scr[n]);
+              make_c2_1(series, found, listc1, boxc1, imin, EPSMAX1,
+                        EPSMAX, EPSMIN, MINDIST, HOWOFTEN, scr[n]);
+              for (octave_idx_type i=imin;i<HOWOFTEN;i++)
+                norm[i] += (double)(lnorm);
             }
 
 
-          // Assign outputs
-          retval(0) = values;
-          retval(1) = vars;
+          // If any of the below occurs: pause or end.
+          if (((time(NULL)-lasttime) > WHEN) || (n == (nmax-1)) || 
+              (imin > (HOWOFTEN-1)) || (counter % it_pause == 0))
+            {
+              time(&lasttime);
+
+              if (imin > (HOWOFTEN-1))
+                {
+                  // old exit(0);
+                  imin_too_large = true;
+                }
+              pause_calc = true;
+            }
+        }
+
+      // Create vars output
+      octave_scalar_map vars;
+
+
+      // Create vars output
+      // old fprintf(fstat,"Center points treated so far= %ld\n",n);
+      vars.setfield ("treated", counter);
+      // old fprintf(fstat,"Maximum epsilon in the moment= %e\n",
+      //             epsm[imin]);
+      vars.setfield ("eps", epsm[imin]);
+
+      if (counter < nmax - 1 && imin_too_large == false)
+        {
+          vars.setfield ("counter", counter);
+          vars.setfield ("found", found_matrix);
+          vars.setfield ("norm", norm_matrix);
+          vars.setfield ("boxc1", boxc1_matrix);
+          vars.setfield ("box", box_matrix);
+          vars.setfield ("list", list_matrix);
+          vars.setfield ("listc1", listc1_matrix);
+          vars.setfield ("imin", imin);
+          vars.setfield ("EPSMAX1",EPSMAX1);
+          vars.setfield ("EPSMAX", EPSMAX);
+          vars.setfield ("EPSMIN", EPSMIN);
         }
 
+      // Create values output
+      dim_vector dv (DIM * EMBED, 1);
+      string_vector keys;
+      keys.append (std::string("dim"));
+      keys.append (std::string("c2"));
+      keys.append (std::string("d2"));
+      keys.append (std::string("h2"));
+      octave_map values (dv, keys);
+
+      for (octave_idx_type i=0;i<DIM*EMBED;i++)
+        {
+
+          octave_scalar_map tmp (keys);
+
+          // old fprintf(fout,"#dim= %ld\n",i+1);
+          tmp.setfield ("dim", i+1);
+
+          // Allocate d2 output
+          Matrix d2_out (HOWOFTEN - 1, 2);
+          octave_idx_type d2_row = 0;
+
+          // Allocate h2 output
+          Matrix h2_out (HOWOFTEN, 2);
+          octave_idx_type h2_row = 0;
+
+          // Allocate c2 output
+          Matrix c2_out (HOWOFTEN, 2);
+          octave_idx_type c2_row = 0;
+
+          double eps = EPSMAX1 * epsfactor;
+
+          for (octave_idx_type j=0;j<HOWOFTEN;j++)
+            {
+              eps /= epsfactor;
+
+              // Calculate d2 output
+              if ((j > 0) && (found[i][j] > 0.0)
+                  && (found[i][j-1] > 0.0))
+                {
+                  // old fprintf(fout,"%e %e\n",eps,
+                  //      log(found[i][j-1]/found[i][j]/norm[j-1]
+                  //          *norm[j])
+                  //      /log(epsfactor));
+                  d2_out(d2_row,0) = eps;
+                  d2_out(d2_row,1) = log(found[i][j-1]/found[i][j]
+                                         /norm[j-1]*norm[j])
+                                     /log(epsfactor);
+                  d2_row          += 1;
+                }
+
+              // Calculate h2 output
+              if (i < 1)
+                {
+                  if (found[0][j] > 0.0)
+                    {
+                      // old fprintf(fout,"%e %e\n",eps,
+                      //             -log(found[0][j]/norm[j]));
+                      h2_out(h2_row,0) = eps;
+                      h2_out(h2_row,1) = -log(found[0][j]/norm[j]);
+                      h2_row          += 1;
+                    }
+                }
+              else
+                {
+                  if ((found[i-1][j] > 0.0) && (found[i][j] > 0.0))
+                    {
+                    // old fprintf(fout,"%e %e\n",eps,
+                    //             log(found[i-1][j]/found[i][j]));
+                      h2_out(h2_row,0) = eps;
+                      h2_out(h2_row,1) = log(found[i-1][j]
+                                             /found[i][j]);
+                      h2_row          += 1;
+                    }
+                }
+
+              // Calculate c2 output
+              if (norm[j] > 0.0)
+                {
+                  // old fprintf(fout,"%e %e\n",eps,
+                  //             found[i][j]/norm[j]);
+                  c2_out(c2_row,0) = eps;
+                  c2_out(c2_row,1) = found[i][j]/norm[j];
+                  c2_row          += 1;
+                }
+            }
+          // Prepare d2 output
+          d2_out.resize (d2_row, 2);
+          tmp.setfield ("d2", d2_out);
+          // Prepare h2 output
+          h2_out.resize (h2_row, 2);
+          tmp.setfield ("h2", h2_out);
+          // Prepare c2 output
+          c2_out.resize (c2_row, 2);
+          tmp.setfield ("c2", c2_out);
+
+          values.assign (idx_vector(i), tmp);
+        }
+
+
+      // Assign outputs
+      retval(0) = values;
+      retval(1) = vars;
     }
+
   return retval;
 }
